' ------------------------------------------------------------------------
'
'     VBAust1.BAS -- Demonstration of Windows API Access
'
'                       Copyright (C) 1993 Desaware
'
'  You have a royalty-free right to use, modify, reproduce and distribute
'  this file (and/or any modified version) in any way you find useful,
'  provided that you agree that Desaware has no
'  warranty, obligation or liability for its contents.
'
' ------------------------------------------------------------------------
Option Explicit

Type RECT   '8 Bytes
    left As Integer
    top As Integer
    right As Integer
    bottom As Integer
End Type

Type POINTAPI  '4 Bytes - Synonymous with LONG
    X As Integer
    Y As Integer
End Type

Type SIZEAPI  '4 Bytes - Synonymous with LONG
    X As Integer
    Y As Integer
End Type

Global Const VK_NUMLOCK = &H90
Global Const VK_SCROLL = &H91
Global Const VK_CAPITAL = &H14

Global Const SRCCOPY = &HCC0020 ' (DWORD) dest = source

Global Const BITSPIXEL = 12 '  Number of bits per pixel
Global Const PLANES = 14    '  Number of planes

Global Const DT_WORDBREAK = &H10

Global Const GWW_HINSTANCE = (-6)

Global Const WM_USER = &H400
Global Const EM_GETLINECOUNT = WM_USER + 10

Global Const MF_INSERT = &H0
Global Const MF_CHANGE = &H80
Global Const MF_APPEND = &H100
Global Const MF_DELETE = &H200
Global Const MF_REMOVE = &H1000

Global Const MF_BYCOMMAND = &H0
Global Const MF_BYPOSITION = &H400

Global Const MF_SEPARATOR = &H800

Global Const MF_ENABLED = &H0
Global Const MF_GRAYED = &H1
Global Const MF_DISABLED = &H2

Global Const MF_UNCHECKED = &H0
Global Const MF_CHECKED = &H8
Global Const MF_USECHECKBITMAPS = &H200

Global Const MF_STRING = &H0
Global Const MF_BITMAP = &H4
Global Const MF_OWNERDRAW = &H100

Global Const MF_POPUP = &H10
Global Const MF_MENUBARBREAK = &H20
Global Const MF_MENUBREAK = &H40

Global Const MF_UNHILITE = &H0
Global Const MF_HILITE = &H80

Global Const MF_SYSMENU = &H2000
Global Const MF_HELP = &H4000
Global Const MF_MOUSESELECT = &H8000


Declare Function BitBlt% Lib "GDI" (ByVal hDestDC%, ByVal X%, ByVal Y%, ByVal nWidth%, ByVal nHeight%, ByVal hSrcDC%, ByVal XSrc%, ByVal YSrc%, ByVal dwRop&)
Declare Sub CloseWindow Lib "User" (ByVal hWnd%)
Declare Function CreateSolidBrush% Lib "GDI" (ByVal crColor&)
Declare Function DrawText% Lib "User" (ByVal hDC%, ByVal lpStr$, ByVal nCount%, lpRect As RECT, ByVal wFormat%)
Declare Function FindWindowByString% Lib "User" Alias "FindWindow" (ByVal lpClassName&, ByVal lpWindowName$)
Declare Sub GetClientRect Lib "User" (ByVal hWnd%, lpRect As RECT)
Declare Function GetDeviceCaps% Lib "GDI" (ByVal hDC%, ByVal nIndex%)
Declare Function GetKeyState% Lib "User" (ByVal nVirtKey%)
Declare Function GetMenu% Lib "User" (ByVal hWnd%)
Declare Function GetMenuCheckMarkDimensions& Lib "User" ()
Declare Function GetMenuItemCount% Lib "User" (ByVal hMenu%)
Declare Function GetMenuItemId% Lib "User" (ByVal hMenu%, ByVal nPos%)
Declare Function GetModuleUsage% Lib "Kernel" (ByVal hModule%)
Declare Function GetProfileString% Lib "Kernel" (ByVal lpAppName$, ByVal lpKeyName As Any, ByVal lpDefault$, ByVal lpReturnedString$, ByVal nSize%)
Declare Function GetSubMenu% Lib "User" (ByVal hMenu%, ByVal nPos%)
Declare Sub GetWindowRect Lib "User" (ByVal hWnd%, lpRect As RECT)
Declare Function GetWindowWord% Lib "User" (ByVal hWnd%, ByVal nIndex%)
Declare Sub InflateRect Lib "User" (lpRect As RECT, ByVal X%, ByVal Y%)
Declare Function ModifyMenu% Lib "User" (ByVal hMenu%, ByVal nPosition%, ByVal wFlags%, ByVal wIDNewItem%, ByVal lpString As Any)
Declare Function ModifyMenuBynum% Lib "User" Alias "ModifyMenu" (ByVal hMenu%, ByVal nPosition%, ByVal wFlags%, ByVal wIDNewItem%, ByVal lpString&)
Declare Function ModifyMenuBystring% Lib "User" Alias "ModifyMenu" (ByVal hMenu%, ByVal nPosition%, ByVal wFlags%, ByVal wIDNewItem%, ByVal lpString$)
Declare Function Rectangle% Lib "GDI" (ByVal hDC%, ByVal X1%, ByVal Y1%, ByVal X2%, ByVal Y2%)
Declare Function DeleteObject% Lib "GDI" (ByVal hObject%)
Declare Function SelectObject% Lib "GDI" (ByVal hDC%, ByVal hObject%)
Declare Function SendMessageBynum& Lib "User" Alias "SendMessage" (ByVal hWnd%, ByVal wMsg%, ByVal wParam%, ByVal lParam&)
Declare Sub SetWindowText Lib "User" (ByVal hWnd%, ByVal lpString$)



